"use strict";
this.name        = "upsAsteroid";
this.author      = "spara";
this.copyright   = "2014 Mika Spara";
this.licence     = "CC BY-NC-SA 3.0";
this.description = "Code for special asteroids/boulders/splinters";

//add position marker when asteroid/boulder with this ship_script is destroyed to script the spawned debris.
this.shipDied = function() {
	system.addVisualEffect("ups_position_marker", this.ship.position);
    if (worldScripts["ups_docs"].ups_docs === "ASTEROID" && ship.$upsAsteroid)
    {
        // doing the asteroid mission
        missionVariables.ups_asteroid_count-- ;
    }
}

//marker has been spawned, wait for 0.1 seconds so that the game has time to spawn boulders/splinters
this.effectSpawned = function() {
	this.debrisTimer = new Timer(this, this.$scanDebris, 0.1);
}

//scan for boulders/splinters and script accordingly
this.$scanDebris = function() {
	//if there are asteroids/boulders close by, assume that they are products of just destroyed asteroid and script them. this method also works with asteroids from asteroid storm oxp and griffs rock chunks.
	var rocks = system.entitiesWithScanClass("CLASS_ROCK", this.visualEffect, 1000);
	for (var i = 0; i < rocks.length; i++) {
		rocks[i].setScript("upsAsteroid.js");
	}
	//if there are splinters close by, assume that they are products of just destroyed boulder and add valuables to them.
	var splinters = system.shipsWithPrimaryRole("splinter", this.visualEffect, 1000)

	for (var i = 0; i < splinters.length; i++) {
		if (splinters[i].commodity === "minerals") {
			var position = splinters[i].position;
			splinters[i].explode();
			splinters[i] = system.addShips("ups-splinter", 1, position, 0)[0];
			splinters[i].temperature = 0.99;
			splinters[i].primaryRole = "splinter";
			var amount = Math.ceil(Math.random() * 12);
			var metal = Math.random() < 0.40 ? "platinum" : "gold";
			splinters[i].setCargo(metal, amount);
			//make the splinters to be identified with the ore processors scanning function correctly
			splinters[i].$oreProcessor = {
				type: metal,
				quantity: amount
			};
		}
	}
	this.visualEffect.remove();
}
