"use strict";
this.name      = "upsBoa";
this.author    = "eric walch, spara";
this.copyright = "2008 eric walch. 2014 spara";
this.license   = "CC BY-NC-SA 3.0";

this.shipSpawned = function ()
{
    this.oldStatus = 100; // real ship bounty
	this.checkPlayerTimer = new Timer(this, this.checkPlayer, 20, 10);
	//name escorts with randomshipnames, if present -spara-
	if (worldScripts.randomshipnames && this.ship.escorts) {
		for (var i = 0; i < this.ship.escorts.length; i++) {
			var shipName = worldScripts.randomshipnames.$randomHunterName(ship);
			this.ship.escorts[i].displayName = this.ship.escorts[i].displayName + ": " + shipName;
		}
	}
	//order escorts with escort formations, if present -spara-
	if (worldScripts["Escort Formations Randomiser"])
		worldScripts["Escort Formations Randomiser"].$setupDefensiveEscorts(this.ship);
    delete this.shipSpawned;
}

this.shipDied = function (whom, why)
{
   log("UPS-Courier", "Hostile BOA killed by " + whom + " by means of " + why);
   if (whom && whom.isPlayer && !player.ship.isCloaked)
   {
      missionVariables.ups_closecontact = "YES"; // Killer was the player
   }
   else
   {
      missionVariables.ups_closecontact = "NO"; // Killer was an NPC or player was cloaked.
   }
    this.ship.commsMessage("I'll be back with help for revenge!!");
    this.ship.spawn("ups-spilled-container", 5);
    this.ship.spawn("ups-textilecontainer", 15);
    worldScripts["ups_container"].ups_container_count = 0;
	worldScripts["ups_container"].ups_total_container_count = 0;
	worldScripts["ups_container"].ups_container_award = 0;
    worldScripts["ups_container"].ups_container = "FOUND";
    worldScripts["ups_container"].upsUnmarkSystem(missionVariables.ups_cplanet, "ups_container");
    mission.setInstructionsKey("ups_containers_small1c", "ups_container");
	if (this.checkPlayerTimer) {this.checkPlayerTimer.stop(); delete this.checkPlayerTimer};
    delete this.shipDied;
}

this.shipBeingAttacked = function (whom)
{
	if (this.ship.escorts && Math.random() > 0.7) this.ship.deployEscorts();
	if (!whom.isPlayer && player.ship.position && player.ship.position.distanceTo(this.ship) > 20E3) whom.reactToAIMessage("TARGET_LOST");
}

// is only activated on real dockings. Sometimes ships are also removed from the docking queue on player launch.
this.shipDockedWithStation = function (station)
{
    log("UPS-Courier", "Hostile BOA docked at station: "+ station.name);
    mission.setInstructionsKey("ups_container_boa_docked_small", "ups_container");
	missionVariables.ups_closecontact = "DOCKED";
	if (this.checkPlayerTimer) {this.checkPlayerTimer.stop(); delete this.checkPlayerTimer};
}

this.entityDestroyed = function ()
{
    if (this.checkPlayerTimer) {this.checkPlayerTimer.stop(); delete this.checkPlayerTimer};
}

this.sendAwayOffender = function ()
{
	if (!this.ship.target.isPlayer && player.ship.position && player.ship.position.distanceTo(this.ship) > 20E3) this.ship.target.reactToAIMessage("TARGET_LOST");
}

// Setting clean on/off is only to draw no police attention when there is no player nearby.
this.checkPlayer = function ()
{
	if (this.ship && !this.ship.isValid)
	{
		log(this.name, "ERROR detected, this.ship is undefined"); // Oolite bug
		if (this.checkPlayerTimer) {this.checkPlayerTimer.stop(); delete this.checkPlayerTimer};
		if (this.checkPlayer) delete this.checkPlayer;
		return;
	}
	if (player.ship.position && player.ship.position.distanceTo(this.ship) > 30E3) this.setClean()
	else this.setFugitive();
}

this.setClean = function ()
{
    if (this.oldStatus == 0)
    {
        this.oldStatus = this.ship.bounty;
        this.ship.bounty = 0;
		if (this.ship.escorts) this.setEscortBounty(0);
    }
}

this.setFugitive = function ()
{
    if (this.oldStatus > 0)
    {
        this.ship.bounty = this.oldStatus;
        this.oldStatus = 0;
		if (this.ship.escorts) this.setEscortBounty(30);
    }
}

this.setEscortBounty = function (bounty)
{
	var escorts = this.ship.escorts;
    for (var i=0; i<escorts.length; i++)
	{
		if (escorts[i].AIState == "FLYING_ESCORT")
        {
            escorts[i].bounty = Math.round(Math.random()*bounty + bounty/10);
        }
	}
}
