"use strict";
this.name      = "fuelLeakUps";
this.author    = "eric walch";
this.copyright = "2008 eric walch.";
this.license   = "CC BY-NC-SA 3.0";

this.shipSpawned = function ()
{
    this.collisionDistance = this.ship.collisionRadius + player.ship.collisionRadius;
    this.shipName = this.ship.displayName;
    delete this.shipSpawned;
}

this.shipDied = function (whom, why)
{
    if(this.ship.subEntities && this.ship.subEntities.length > 0) // ship still has subentities.
    {
        for (var i=0; i<this.ship.subEntities.length; i++)
        {
            var silo = this.ship.spawnOne(this.ship.subEntities[i].primaryRole);
            var siloPosition = this.ship.subEntities[i].position;
            siloPosition = siloPosition.multiply(3);
            siloPosition = this.localToGlobal(siloPosition);
            if (silo && silo.isValid)
            {
                silo.orientation = this.ship.orientation;
                silo.position = siloPosition;
            }
        }
    }
}

this.localToGlobal = function (position)
{
	return this.ship.position.add(position.rotateBy(this.ship.orientation));
}

this.payment = 0;

this.checkLocation = function ()
{
  if (system.isInterstellarSpace)
  {
    player.consoleMessage("I'll give you fuel for " + 1500 * (7 - player.ship.fuel) + " credits.", 9);
    this.amount = 1500;
  }
  else
  {
    player.consoleMessage("This entry point iS unsafe and causes fuel leaks.", 9);
    this.amount = 150;
    player.ship.fuelLeakRate = 20;
  }
}

this.checkDistance = function ()
{
  var distance = Math.round(player.ship.position.distanceTo(this.ship));
  if (distance < 6000)
  {
      player.consoleMessage("You are on approach, lower your speed", 9);
      this.ship.displayName = this.shipName + " with fuel";
      this.ship.reactToAIMessage("UPS_PLAYER_APPROACHING");
  }
}

this.guideIn = function ()
{
    var distance = Math.round(player.ship.position.distanceTo(this.ship) - this.collisionDistance);
    if (distance < 0) distance = 0;
    var speed = Math.round(player.ship.speed);
    if (distance > 7000)
    {
        this.ship.reactToAIMessage("UPS_PLAYER_LEAVING");
        return;
    }
    if (distance > 1500)
    {
        if (speed > 100) player.consoleMessage("Approaching with: " + speed + "km/h, lower your speed.", 4);
    }
    else
    {
        if (speed > 50) player.consoleMessage("Approaching with: " + speed + "km/h, lower your speed to 50 km/h.", 4);
        player.consoleMessage("You are at " + distance + " meters, come to a complete standstill within 100 meters.", 4);
    }
    if (distance < 100 && speed == 0)
    {
        this.ship.reactToAIMessage("UPS_PLAYER_CLOSE");
        this.oldOrientation = player.ship.orientation;
    }
}

this.checkSpeed = function ()
{
    if (player.ship.speed > 0.001 || this.oldOrientation.dot(player.ship.orientation) < 0.999)
    {
        player.consoleMessage("You are moving to much, hold stil", 4);
        this.ship.reactToAIMessage("UPS_PLAYER_APPROACHING");
    }
    else
    {
        if (player.ship.fuel < 7 && player.credits > this.amount)
        {
            player.consoleMessage("Transfering fuel... " + Math.round(player.ship.fuel), 3);
            player.ship.fuel += 1;
            this.payment += this.amount;
            player.credits -= this.amount;
        }
        else
        {
            if (this.payment === 0)
            {
                player.commsMessage("No money no fuel. I can't help you", 6);
            }
            else
            {
                player.commsMessage("I took " + this.payment + " credits as payment.",6)
                this.ship.reactToAIMessage("UPS_TRANSFERING_OK");
                this.ship.target = null;
            }
        }
        this.ship.displayName = this.shipName; // restore original name
    }
}
