"use strict";
this.name      = "upsMarket_earthquake";
this.author    = "spara";
this.copyright = "2014 spara";
this.license   = "CC BY-NC-SA 4.0";

this.$originalDefs = {
    "food": [0, 0, 19, -2, -2, 0, 1, 1, 0 ],
    "textiles": [0, 0, 20, -1, -1, 0, 3, 3, 0 ],
    "radioactives": [0, 0, 65, -3, -3, 0, 7, 3, 0 ],
    "slaves": [0, 0, 40, -5, 0, 0, 31, 0, 0],
    "liquor_wines": [0, 0, 83, -5, -5, 0, 15, 7, 0 ],
    "luxuries": [0, 0, 196, 8, 8, 0, 3, 3, 0 ],
    "narcotics": [0, 0, 235, 29, 29, 0, 120, 63, 0 ],
    "computers": [0, 0, 154, 14, 14, 0, 3, 1, 0 ],
    "machinery": [0, 0, 196, 6, 6, 0, 7, 0, 0 ],
    "alloys": [0, 0, 78, 1, 1, 0, 31, 15, 0 ],
    "firearms": [0, 0, 124, 13, 13, 0, 7, 3, 0 ],
    "furs": [0, 0, 176, -9, -9, 0, 63, 31, 0 ],
    "minerals": [0, 0, 32, -1, -1, 0, 3, 1, 0 ],
    "gold": [0, 0, 97, -1, -1, 0, 7, 3, 1 ],
    "platinum": [0, 0, 171, -2, -2, 0, 31, 15, 1 ],
    "gem_stones": [0, 0, 45, -1, -1, 0, 15, 7, 2 ],
    "alien_items": [0, 0, 53, 15, 0, 0, 7, 0, 0 ]
};

this.updateLocalCommodityDefinition = function(goodDefinition) {
    if (system.ID !== worldScripts.ups_docs.ups_dplanet || worldScripts.ups_docs.mark === false) {
        return goodDefinition;
    }
	var commodity = goodDefinition.key;
	var oldDefs = this.$originalDefs[commodity];
	//old style definition found for the good. calculate it the old way
	if (oldDefs) {
		var market_base_price = oldDefs[2];
		var market_eco_adjust_price = oldDefs[3];
		var market_eco_adjust_quantity = oldDefs[4];
		var market_base_quantity = oldDefs[5];
		var market_mask_price = oldDefs[6];
		var market_mask_quantity = oldDefs[7];
		var market_rnd = Math.floor(Math.random() * 256);

		var economy = system.economy;

		var price = (market_base_price + (market_rnd & market_mask_price) + (economy * market_eco_adjust_price)) & 255;
		price *= 0.4;

		var quantity = (market_base_quantity + (market_rnd & market_mask_quantity) - (economy * market_eco_adjust_quantity)) & 255;
		if (quantity > 127) quantity = 0;
		quantity &= 63;

		goodDefinition.price = price * 10;
		goodDefinition.quantity = quantity;
	}
	//no definition found. nullify the goods.
	else {
		goodDefinition.price = 0;
		goodDefinition.quantity = 0;
	}
	return goodDefinition;
};
